<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/syn-1.0.98/src/buffer.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>buffer.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../syn/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
</pre><pre class="rust"><code><span class="doccomment">//! A stably addressed token buffer supporting efficient traversal based on a</span>
<span class="doccomment">//! cheaply copyable cursor.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! *This module is available only if Syn is built with the `&quot;parsing&quot;` feature.*</span>

<span class="comment">// This module is heavily commented as it contains most of the unsafe code in</span>
<span class="comment">// Syn, and caution should be used when editing it. The public-facing interface</span>
<span class="comment">// is 100% safe but the implementation is fragile internally.</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
))]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::proc_macro</span> <span class="kw">as</span> <span class="ident">pm</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Lifetime</span>;
<span class="kw">use</span> <span class="ident">proc_macro2</span>::{<span class="ident">Delimiter</span>, <span class="ident">Group</span>, <span class="ident">Ident</span>, <span class="ident">Literal</span>, <span class="ident">Punct</span>, <span class="ident">Spacing</span>, <span class="ident">Span</span>, <span class="ident">TokenStream</span>, <span class="ident">TokenTree</span>};
<span class="kw">use</span> <span class="ident">std::marker::PhantomData</span>;
<span class="kw">use</span> <span class="ident">std::ptr</span>;
<span class="kw">use</span> <span class="ident">std::slice</span>;

<span class="doccomment">/// Internal type which is used instead of `TokenTree` to represent a token tree</span>
<span class="doccomment">/// within a `TokenBuffer`.</span>
<span class="kw">enum</span> <span class="ident">Entry</span> {
    <span class="comment">// Mimicking types from proc-macro.</span>
    <span class="ident">Group</span>(<span class="ident">Group</span>, <span class="ident">TokenBuffer</span>),
    <span class="ident">Ident</span>(<span class="ident">Ident</span>),
    <span class="ident">Punct</span>(<span class="ident">Punct</span>),
    <span class="ident">Literal</span>(<span class="ident">Literal</span>),
    <span class="comment">// End entries contain a raw pointer to the entry from the containing</span>
    <span class="comment">// token tree, or null if this is the outermost level.</span>
    <span class="ident">End</span>(<span class="kw-2">*const</span> <span class="ident">Entry</span>),
}

<span class="doccomment">/// A buffer that can be efficiently traversed multiple times, unlike</span>
<span class="doccomment">/// `TokenStream` which requires a deep copy in order to traverse more than</span>
<span class="doccomment">/// once.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This type is available only if Syn is built with the `&quot;parsing&quot;` feature.*</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">TokenBuffer</span> {
    <span class="comment">// NOTE: Do not implement clone on this - there are raw pointers inside</span>
    <span class="comment">// these entries which will be messed up. Moving the `TokenBuffer` itself is</span>
    <span class="comment">// safe as the data pointed to won&#39;t be moved.</span>
    <span class="ident">ptr</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>,
    <span class="ident">len</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">TokenBuffer</span> {
    <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">slice</span> <span class="op">=</span> <span class="ident">slice::from_raw_parts_mut</span>(<span class="self">self</span>.<span class="ident">ptr</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Entry</span>, <span class="self">self</span>.<span class="ident">len</span>);
            <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="ident">Box::from_raw</span>(<span class="ident">slice</span>);
        }
    }
}

<span class="kw">impl</span> <span class="ident">TokenBuffer</span> {
    <span class="comment">// NOTE: Do not mutate the Vec returned from this function once it returns;</span>
    <span class="comment">// the address of its backing memory must remain stable.</span>
    <span class="kw">fn</span> <span class="ident">inner_new</span>(<span class="ident">stream</span>: <span class="ident">TokenStream</span>, <span class="ident">up</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>) -&gt; <span class="ident">TokenBuffer</span> {
        <span class="comment">// Build up the entries list, recording the locations of any Groups</span>
        <span class="comment">// in the list to be processed later.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">entries</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">groups</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">for</span> <span class="ident">tt</span> <span class="kw">in</span> <span class="ident">stream</span> {
            <span class="kw">match</span> <span class="ident">tt</span> {
                <span class="ident">TokenTree::Ident</span>(<span class="ident">sym</span>) =&gt; {
                    <span class="ident">entries</span>.<span class="ident">push</span>(<span class="ident">Entry::Ident</span>(<span class="ident">sym</span>));
                }
                <span class="ident">TokenTree::Punct</span>(<span class="ident">op</span>) =&gt; {
                    <span class="ident">entries</span>.<span class="ident">push</span>(<span class="ident">Entry::Punct</span>(<span class="ident">op</span>));
                }
                <span class="ident">TokenTree::Literal</span>(<span class="ident">l</span>) =&gt; {
                    <span class="ident">entries</span>.<span class="ident">push</span>(<span class="ident">Entry::Literal</span>(<span class="ident">l</span>));
                }
                <span class="ident">TokenTree::Group</span>(<span class="ident">g</span>) =&gt; {
                    <span class="comment">// Record the index of the interesting entry, and store an</span>
                    <span class="comment">// `End(null)` there temporarily.</span>
                    <span class="ident">groups</span>.<span class="ident">push</span>((<span class="ident">entries</span>.<span class="ident">len</span>(), <span class="ident">g</span>));
                    <span class="ident">entries</span>.<span class="ident">push</span>(<span class="ident">Entry::End</span>(<span class="ident">ptr::null</span>()));
                }
            }
        }
        <span class="comment">// Add an `End` entry to the end with a reference to the enclosing token</span>
        <span class="comment">// stream which was passed in.</span>
        <span class="ident">entries</span>.<span class="ident">push</span>(<span class="ident">Entry::End</span>(<span class="ident">up</span>));

        <span class="comment">// NOTE: This is done to ensure that we don&#39;t accidentally modify the</span>
        <span class="comment">// length of the backing buffer. The backing buffer must remain at a</span>
        <span class="comment">// constant address after this point, as we are going to store a raw</span>
        <span class="comment">// pointer into it.</span>
        <span class="kw">let</span> <span class="ident">entries</span> <span class="op">=</span> <span class="ident">entries</span>.<span class="ident">into_boxed_slice</span>();
        <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> <span class="ident">entries</span>.<span class="ident">len</span>();
        <span class="comment">// Convert boxed slice into a pointer to the first element early, to</span>
        <span class="comment">// avoid invalidating pointers into this slice when we move the Box.</span>
        <span class="comment">// See https://github.com/rust-lang/unsafe-code-guidelines/issues/326</span>
        <span class="kw">let</span> <span class="ident">entries</span> <span class="op">=</span> <span class="ident">Box::into_raw</span>(<span class="ident">entries</span>) <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Entry</span>;
        <span class="kw">for</span> (<span class="ident">idx</span>, <span class="ident">group</span>) <span class="kw">in</span> <span class="ident">groups</span> {
            <span class="comment">// We know that this index refers to one of the temporary</span>
            <span class="comment">// `End(null)` entries, and we know that the last entry is</span>
            <span class="comment">// `End(up)`, so the next index is also valid.</span>
            <span class="kw">let</span> <span class="ident">group_up</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">entries</span>.<span class="ident">add</span>(<span class="ident">idx</span> <span class="op">+</span> <span class="number">1</span>) };

            <span class="comment">// The end entry stored at the end of this Entry::Group should</span>
            <span class="comment">// point to the Entry which follows the Group in the list.</span>
            <span class="kw">let</span> <span class="ident">inner</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::inner_new</span>(<span class="ident">group</span>.<span class="ident">stream</span>(), <span class="ident">group_up</span>);
            <span class="kw">unsafe</span> { <span class="kw-2">*</span><span class="ident">entries</span>.<span class="ident">add</span>(<span class="ident">idx</span>) <span class="op">=</span> <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="ident">inner</span>) };
        }

        <span class="ident">TokenBuffer</span> { <span class="ident">ptr</span>: <span class="ident">entries</span>, <span class="ident">len</span> }
    }

    <span class="doccomment">/// Creates a `TokenBuffer` containing all the tokens from the input</span>
    <span class="doccomment">/// `proc_macro::TokenStream`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// *This method is available only if Syn is built with both the `&quot;parsing&quot;` and</span>
    <span class="doccomment">/// `&quot;proc-macro&quot;` features.*</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
        <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
    ))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">stream</span>: <span class="ident">pm::TokenStream</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::new2</span>(<span class="ident">stream</span>.<span class="ident">into</span>())
    }

    <span class="doccomment">/// Creates a `TokenBuffer` containing all the tokens from the input</span>
    <span class="doccomment">/// `proc_macro2::TokenStream`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new2</span>(<span class="ident">stream</span>: <span class="ident">TokenStream</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::inner_new</span>(<span class="ident">stream</span>, <span class="ident">ptr::null</span>())
    }

    <span class="doccomment">/// Creates a cursor referencing the first token in the buffer and able to</span>
    <span class="doccomment">/// traverse until the end of the buffer.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">begin</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Cursor</span> {
        <span class="kw">unsafe</span> { <span class="ident">Cursor::create</span>(<span class="self">self</span>.<span class="ident">ptr</span>, <span class="self">self</span>.<span class="ident">ptr</span>.<span class="ident">add</span>(<span class="self">self</span>.<span class="ident">len</span> <span class="op">-</span> <span class="number">1</span>)) }
    }
}

<span class="doccomment">/// A cheaply copyable cursor into a `TokenBuffer`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This cursor holds a shared reference into the immutable data which is used</span>
<span class="doccomment">/// internally to represent a `TokenStream`, and can be efficiently manipulated</span>
<span class="doccomment">/// and copied around.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// An empty `Cursor` can be created directly, or one may create a `TokenBuffer`</span>
<span class="doccomment">/// object and get a cursor to its first token with `begin()`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Two cursors are equal if they have the same location in the same input</span>
<span class="doccomment">/// stream, and have the same scope.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This type is available only if Syn is built with the `&quot;parsing&quot;` feature.*</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="comment">// The current entry which the `Cursor` is pointing at.</span>
    <span class="ident">ptr</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>,
    <span class="comment">// This is the only `Entry::End(..)` object which this cursor is allowed to</span>
    <span class="comment">// point at. All other `End` objects are skipped over in `Cursor::create`.</span>
    <span class="ident">scope</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>,
    <span class="comment">// Cursor is covariant in &#39;a. This field ensures that our pointers are still</span>
    <span class="comment">// valid.</span>
    <span class="ident">marker</span>: <span class="ident">PhantomData</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Entry</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Creates a cursor referencing a static empty TokenStream.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">empty</span>() -&gt; <span class="self">Self</span> {
        <span class="comment">// It&#39;s safe in this situation for us to put an `Entry` object in global</span>
        <span class="comment">// storage, despite it not actually being safe to send across threads</span>
        <span class="comment">// (`Ident` is a reference into a thread-local table). This is because</span>
        <span class="comment">// this entry never includes a `Ident` object.</span>
        <span class="comment">//</span>
        <span class="comment">// This wrapper struct allows us to break the rules and put a `Sync`</span>
        <span class="comment">// object in global storage.</span>
        <span class="kw">struct</span> <span class="ident">UnsafeSyncEntry</span>(<span class="ident">Entry</span>);
        <span class="kw">unsafe</span> <span class="kw">impl</span> <span class="ident">Sync</span> <span class="kw">for</span> <span class="ident">UnsafeSyncEntry</span> {}
        <span class="kw">static</span> <span class="ident">EMPTY_ENTRY</span>: <span class="ident">UnsafeSyncEntry</span> <span class="op">=</span> <span class="ident">UnsafeSyncEntry</span>(<span class="ident">Entry::End</span>(<span class="number">0</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">Entry</span>));

        <span class="ident">Cursor</span> {
            <span class="ident">ptr</span>: <span class="kw-2">&amp;</span><span class="ident">EMPTY_ENTRY</span>.<span class="number">0</span>,
            <span class="ident">scope</span>: <span class="kw-2">&amp;</span><span class="ident">EMPTY_ENTRY</span>.<span class="number">0</span>,
            <span class="ident">marker</span>: <span class="ident">PhantomData</span>,
        }
    }

    <span class="doccomment">/// This create method intelligently exits non-explicitly-entered</span>
    <span class="doccomment">/// `None`-delimited scopes when the cursor reaches the end of them,</span>
    <span class="doccomment">/// allowing for them to be treated transparently.</span>
    <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">create</span>(<span class="kw-2">mut</span> <span class="ident">ptr</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>, <span class="ident">scope</span>: <span class="kw-2">*const</span> <span class="ident">Entry</span>) -&gt; <span class="self">Self</span> {
        <span class="comment">// NOTE: If we&#39;re looking at a `End(..)`, we want to advance the cursor</span>
        <span class="comment">// past it, unless `ptr == scope`, which means that we&#39;re at the edge of</span>
        <span class="comment">// our cursor&#39;s scope. We should only have `ptr != scope` at the exit</span>
        <span class="comment">// from None-delimited groups entered with `ignore_none`.</span>
        <span class="kw">while</span> <span class="kw">let</span> <span class="ident">Entry::End</span>(<span class="ident">exit</span>) <span class="op">=</span> <span class="kw-2">*</span><span class="ident">ptr</span> {
            <span class="kw">if</span> <span class="ident">ptr</span> <span class="op">==</span> <span class="ident">scope</span> {
                <span class="kw">break</span>;
            }
            <span class="ident">ptr</span> <span class="op">=</span> <span class="ident">exit</span>;
        }

        <span class="ident">Cursor</span> {
            <span class="ident">ptr</span>,
            <span class="ident">scope</span>,
            <span class="ident">marker</span>: <span class="ident">PhantomData</span>,
        }
    }

    <span class="doccomment">/// Get the current entry.</span>
    <span class="kw">fn</span> <span class="ident">entry</span>(<span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Entry</span> {
        <span class="kw">unsafe</span> { <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="self">self</span>.<span class="ident">ptr</span> }
    }

    <span class="doccomment">/// Bump the cursor to point at the next token after the current one. This</span>
    <span class="doccomment">/// is undefined behavior if the cursor is currently looking at an</span>
    <span class="doccomment">/// `Entry::End`.</span>
    <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">bump</span>(<span class="self">self</span>) -&gt; <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">Cursor::create</span>(<span class="self">self</span>.<span class="ident">ptr</span>.<span class="ident">offset</span>(<span class="number">1</span>), <span class="self">self</span>.<span class="ident">scope</span>)
    }

    <span class="doccomment">/// While the cursor is looking at a `None`-delimited group, move it to look</span>
    <span class="doccomment">/// at the first token inside instead. If the group is empty, this will move</span>
    <span class="doccomment">/// the cursor past the `None`-delimited group.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// WARNING: This mutates its argument.</span>
    <span class="kw">fn</span> <span class="ident">ignore_none</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="kw">while</span> <span class="kw">let</span> <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="ident">buf</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="kw">if</span> <span class="ident">group</span>.<span class="ident">delimiter</span>() <span class="op">==</span> <span class="ident">Delimiter::None</span> {
                <span class="comment">// NOTE: We call `Cursor::create` here to make sure that</span>
                <span class="comment">// situations where we should immediately exit the span after</span>
                <span class="comment">// entering it are handled correctly.</span>
                <span class="kw">unsafe</span> {
                    <span class="kw-2">*</span><span class="self">self</span> <span class="op">=</span> <span class="ident">Cursor::create</span>(<span class="ident">buf</span>.<span class="ident">ptr</span>, <span class="self">self</span>.<span class="ident">scope</span>);
                }
            } <span class="kw">else</span> {
                <span class="kw">break</span>;
            }
        }
    }

    <span class="doccomment">/// Checks whether the cursor is currently pointing at the end of its valid</span>
    <span class="doccomment">/// scope.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">eof</span>(<span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="comment">// We&#39;re at eof if we&#39;re at the end of our scope.</span>
        <span class="self">self</span>.<span class="ident">ptr</span> <span class="op">==</span> <span class="self">self</span>.<span class="ident">scope</span>
    }

    <span class="doccomment">/// If the cursor is pointing at a `Group` with the given delimiter, returns</span>
    <span class="doccomment">/// a cursor into that group and one pointing to the next `TokenTree`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">group</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">delim</span>: <span class="ident">Delimiter</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>, <span class="ident">Span</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="comment">// If we&#39;re not trying to enter a none-delimited group, we want to</span>
        <span class="comment">// ignore them. We have to make sure to _not_ ignore them when we want</span>
        <span class="comment">// to enter them, of course. For obvious reasons.</span>
        <span class="kw">if</span> <span class="ident">delim</span> <span class="op">!</span><span class="op">=</span> <span class="ident">Delimiter::None</span> {
            <span class="self">self</span>.<span class="ident">ignore_none</span>();
        }

        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="ident">buf</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="kw">if</span> <span class="ident">group</span>.<span class="ident">delimiter</span>() <span class="op">==</span> <span class="ident">delim</span> {
                <span class="kw">return</span> <span class="prelude-val">Some</span>((<span class="ident">buf</span>.<span class="ident">begin</span>(), <span class="ident">group</span>.<span class="ident">span</span>(), <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() }));
            }
        }

        <span class="prelude-val">None</span>
    }

    <span class="doccomment">/// If the cursor is pointing at a `Ident`, returns it along with a cursor</span>
    <span class="doccomment">/// pointing at the next `TokenTree`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">ident</span>(<span class="kw-2">mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">Ident</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">ignore_none</span>();
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Ident</span>(<span class="ident">ident</span>) =&gt; <span class="prelude-val">Some</span>((<span class="ident">ident</span>.<span class="ident">clone</span>(), <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() })),
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// If the cursor is pointing at a `Punct`, returns it along with a cursor</span>
    <span class="doccomment">/// pointing at the next `TokenTree`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">punct</span>(<span class="kw-2">mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">Punct</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">ignore_none</span>();
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Punct</span>(<span class="ident">op</span>) <span class="kw">if</span> <span class="ident">op</span>.<span class="ident">as_char</span>() <span class="op">!</span><span class="op">=</span> <span class="string">&#39;\&#39;&#39;</span> =&gt; <span class="prelude-val">Some</span>((<span class="ident">op</span>.<span class="ident">clone</span>(), <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() })),
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// If the cursor is pointing at a `Literal`, return it along with a cursor</span>
    <span class="doccomment">/// pointing at the next `TokenTree`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">literal</span>(<span class="kw-2">mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">Literal</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">ignore_none</span>();
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Literal</span>(<span class="ident">lit</span>) =&gt; <span class="prelude-val">Some</span>((<span class="ident">lit</span>.<span class="ident">clone</span>(), <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() })),
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// If the cursor is pointing at a `Lifetime`, returns it along with a</span>
    <span class="doccomment">/// cursor pointing at the next `TokenTree`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">lifetime</span>(<span class="kw-2">mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">Lifetime</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">ignore_none</span>();
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Punct</span>(<span class="ident">op</span>) <span class="kw">if</span> <span class="ident">op</span>.<span class="ident">as_char</span>() <span class="op">==</span> <span class="string">&#39;\&#39;&#39;</span> <span class="op">&amp;&amp;</span> <span class="ident">op</span>.<span class="ident">spacing</span>() <span class="op">==</span> <span class="ident">Spacing::Joint</span> =&gt; {
                <span class="kw">let</span> <span class="ident">next</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() };
                <span class="kw">match</span> <span class="ident">next</span>.<span class="ident">ident</span>() {
                    <span class="prelude-val">Some</span>((<span class="ident">ident</span>, <span class="ident">rest</span>)) =&gt; {
                        <span class="kw">let</span> <span class="ident">lifetime</span> <span class="op">=</span> <span class="ident">Lifetime</span> {
                            <span class="ident">apostrophe</span>: <span class="ident">op</span>.<span class="ident">span</span>(),
                            <span class="ident">ident</span>,
                        };
                        <span class="prelude-val">Some</span>((<span class="ident">lifetime</span>, <span class="ident">rest</span>))
                    }
                    <span class="prelude-val">None</span> =&gt; <span class="prelude-val">None</span>,
                }
            }
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// Copies all remaining tokens visible from this cursor into a</span>
    <span class="doccomment">/// `TokenStream`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">token_stream</span>(<span class="self">self</span>) -&gt; <span class="ident">TokenStream</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">tts</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cursor</span> <span class="op">=</span> <span class="self">self</span>;
        <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">tt</span>, <span class="ident">rest</span>)) <span class="op">=</span> <span class="ident">cursor</span>.<span class="ident">token_tree</span>() {
            <span class="ident">tts</span>.<span class="ident">push</span>(<span class="ident">tt</span>);
            <span class="ident">cursor</span> <span class="op">=</span> <span class="ident">rest</span>;
        }
        <span class="ident">tts</span>.<span class="ident">into_iter</span>().<span class="ident">collect</span>()
    }

    <span class="doccomment">/// If the cursor is pointing at a `TokenTree`, returns it along with a</span>
    <span class="doccomment">/// cursor pointing at the next `TokenTree`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns `None` if the cursor has reached the end of its stream.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method does not treat `None`-delimited groups as transparent, and</span>
    <span class="doccomment">/// will return a `Group(None, ..)` if the cursor is looking at one.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">token_tree</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">TokenTree</span>, <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">tree</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="kw">_</span>) =&gt; <span class="ident">group</span>.<span class="ident">clone</span>().<span class="ident">into</span>(),
            <span class="ident">Entry::Literal</span>(<span class="ident">lit</span>) =&gt; <span class="ident">lit</span>.<span class="ident">clone</span>().<span class="ident">into</span>(),
            <span class="ident">Entry::Ident</span>(<span class="ident">ident</span>) =&gt; <span class="ident">ident</span>.<span class="ident">clone</span>().<span class="ident">into</span>(),
            <span class="ident">Entry::Punct</span>(<span class="ident">op</span>) =&gt; <span class="ident">op</span>.<span class="ident">clone</span>().<span class="ident">into</span>(),
            <span class="ident">Entry::End</span>(..) =&gt; <span class="kw">return</span> <span class="prelude-val">None</span>,
        };

        <span class="prelude-val">Some</span>((<span class="ident">tree</span>, <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() }))
    }

    <span class="doccomment">/// Returns the `Span` of the current token, or `Span::call_site()` if this</span>
    <span class="doccomment">/// cursor points to eof.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">span</span>(<span class="self">self</span>) -&gt; <span class="ident">Span</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="kw">_</span>) =&gt; <span class="ident">group</span>.<span class="ident">span</span>(),
            <span class="ident">Entry::Literal</span>(<span class="ident">l</span>) =&gt; <span class="ident">l</span>.<span class="ident">span</span>(),
            <span class="ident">Entry::Ident</span>(<span class="ident">t</span>) =&gt; <span class="ident">t</span>.<span class="ident">span</span>(),
            <span class="ident">Entry::Punct</span>(<span class="ident">o</span>) =&gt; <span class="ident">o</span>.<span class="ident">span</span>(),
            <span class="ident">Entry::End</span>(..) =&gt; <span class="ident">Span::call_site</span>(),
        }
    }

    <span class="doccomment">/// Skip over the next token without cloning it. Returns `None` if this</span>
    <span class="doccomment">/// cursor points to eof.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method treats `&#39;lifetimes` as a single token.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">skip</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">entry</span>() {
            <span class="ident">Entry::End</span>(..) =&gt; <span class="prelude-val">None</span>,

            <span class="comment">// Treat lifetimes as a single tt for the purposes of &#39;skip&#39;.</span>
            <span class="ident">Entry::Punct</span>(<span class="ident">op</span>) <span class="kw">if</span> <span class="ident">op</span>.<span class="ident">as_char</span>() <span class="op">==</span> <span class="string">&#39;\&#39;&#39;</span> <span class="op">&amp;&amp;</span> <span class="ident">op</span>.<span class="ident">spacing</span>() <span class="op">==</span> <span class="ident">Spacing::Joint</span> =&gt; {
                <span class="kw">let</span> <span class="ident">next</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() };
                <span class="kw">match</span> <span class="ident">next</span>.<span class="ident">entry</span>() {
                    <span class="ident">Entry::Ident</span>(<span class="kw">_</span>) =&gt; <span class="prelude-val">Some</span>(<span class="kw">unsafe</span> { <span class="ident">next</span>.<span class="ident">bump</span>() }),
                    <span class="kw">_</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">next</span>),
                }
            }
            <span class="kw">_</span> =&gt; <span class="prelude-val">Some</span>(<span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">bump</span>() }),
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Copy</span> <span class="kw">for</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="self">Self</span> {
        <span class="kw-2">*</span><span class="self">self</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Eq</span> <span class="kw">for</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">PartialEq</span> <span class="kw">for</span> <span class="ident">Cursor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">other</span>: <span class="kw-2">&amp;</span><span class="self">Self</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">let</span> <span class="ident">Cursor</span> { <span class="ident">ptr</span>, <span class="ident">scope</span>, <span class="ident">marker</span> } <span class="op">=</span> <span class="self">self</span>;
        <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="ident">marker</span>;
        <span class="kw-2">*</span><span class="ident">ptr</span> <span class="op">==</span> <span class="ident">other</span>.<span class="ident">ptr</span> <span class="op">&amp;&amp;</span> <span class="kw-2">*</span><span class="ident">scope</span> <span class="op">==</span> <span class="ident">other</span>.<span class="ident">scope</span>
    }
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">same_scope</span>(<span class="ident">a</span>: <span class="ident">Cursor</span>, <span class="ident">b</span>: <span class="ident">Cursor</span>) -&gt; <span class="ident">bool</span> {
    <span class="ident">a</span>.<span class="ident">scope</span> <span class="op">==</span> <span class="ident">b</span>.<span class="ident">scope</span>
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">open_span_of_group</span>(<span class="ident">cursor</span>: <span class="ident">Cursor</span>) -&gt; <span class="ident">Span</span> {
    <span class="kw">match</span> <span class="ident">cursor</span>.<span class="ident">entry</span>() {
        <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="kw">_</span>) =&gt; <span class="ident">group</span>.<span class="ident">span_open</span>(),
        <span class="kw">_</span> =&gt; <span class="ident">cursor</span>.<span class="ident">span</span>(),
    }
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">close_span_of_group</span>(<span class="ident">cursor</span>: <span class="ident">Cursor</span>) -&gt; <span class="ident">Span</span> {
    <span class="kw">match</span> <span class="ident">cursor</span>.<span class="ident">entry</span>() {
        <span class="ident">Entry::Group</span>(<span class="ident">group</span>, <span class="kw">_</span>) =&gt; <span class="ident">group</span>.<span class="ident">span_close</span>(),
        <span class="kw">_</span> =&gt; <span class="ident">cursor</span>.<span class="ident">span</span>(),
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>